'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = void 0;

var _react = _interopRequireDefault(require('react'));

var _detectElementResize = _interopRequireDefault(require('./utils/detectElementResize'));

function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : {default: obj};
}

function _typeof(obj) {
  '@babel/helpers - typeof';
  if (typeof Symbol === 'function' && typeof Symbol.iterator === 'symbol') {
    _typeof = function _typeof(obj) {
      return typeof obj;
    };
  } else {
    _typeof = function _typeof(obj) {
      return obj && typeof Symbol === 'function' && obj.constructor === Symbol && obj !== Symbol.prototype
        ? 'symbol'
        : typeof obj;
    };
  }
  return _typeof(obj);
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly)
      symbols = symbols.filter(function(sym) {
        return Object.getOwnPropertyDescriptor(object, sym).enumerable;
      });
    keys.push.apply(keys, symbols);
  }
  return keys;
}

function _objectSpread(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};
    if (i % 2) {
      ownKeys(Object(source), true).forEach(function(key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function(key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }
  return target;
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError('Cannot call a class as a function');
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ('value' in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _possibleConstructorReturn(self, call) {
  if (call && (_typeof(call) === 'object' || typeof call === 'function')) {
    return call;
  }
  return _assertThisInitialized(self);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf
    ? Object.getPrototypeOf
    : function _getPrototypeOf(o) {
        return o.__proto__ || Object.getPrototypeOf(o);
      };
  return _getPrototypeOf(o);
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }
  return self;
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== 'function' && superClass !== null) {
    throw new TypeError('Super expression must either be null or a function');
  }
  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {value: subClass, writable: true, configurable: true}
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf =
    Object.setPrototypeOf ||
    function _setPrototypeOf(o, p) {
      o.__proto__ = p;
      return o;
    };
  return _setPrototypeOf(o, p);
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {value: value, enumerable: true, configurable: true, writable: true});
  } else {
    obj[key] = value;
  }
  return obj;
}

var AutoSizer =
  /*#__PURE__*/
  (function(_React$PureComponent) {
    _inherits(AutoSizer, _React$PureComponent);

    function AutoSizer() {
      var _getPrototypeOf2;

      var _this;

      _classCallCheck(this, AutoSizer);

      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      _this = _possibleConstructorReturn(
        this,
        (_getPrototypeOf2 = _getPrototypeOf(AutoSizer)).call.apply(_getPrototypeOf2, [this].concat(args))
      );

      _defineProperty(_assertThisInitialized(_this), 'state', {
        height: _this.props.defaultHeight || 0,
        width: _this.props.defaultWidth || 0
      });

      _defineProperty(_assertThisInitialized(_this), '_parentNode', void 0);

      _defineProperty(_assertThisInitialized(_this), '_autoSizer', void 0);

      _defineProperty(_assertThisInitialized(_this), '_detectElementResize', void 0);

      _defineProperty(_assertThisInitialized(_this), '_onResize', function() {
        var _this$props = _this.props,
          disableHeight = _this$props.disableHeight,
          disableWidth = _this$props.disableWidth,
          onResize = _this$props.onResize;

        if (_this._parentNode) {
          var height = _this._parentNode.offsetHeight || 0;
          var width = _this._parentNode.offsetWidth || 0;
          var style = window.getComputedStyle(_this._parentNode) || {};
          var paddingLeft = parseInt(style.paddingLeft, 10) || 0;
          var paddingRight = parseInt(style.paddingRight, 10) || 0;
          var paddingTop = parseInt(style.paddingTop, 10) || 0;
          var paddingBottom = parseInt(style.paddingBottom, 10) || 0;
          var borderLeftWidth = parseInt(style.borderLeftWidth, 10) || 0;
          var borderTopWidth = parseInt(style.borderTopWidth, 10) || 0;
          var borderRightWidth = parseInt(style.borderRightWidth, 10) || 0;
          var borderBottomWidth = parseInt(style.borderBottomWidth, 10) || 0;
          var newHeight = height - paddingTop - paddingBottom;
          var newWidth = width - paddingLeft - paddingRight;

          if (style.boxSizing === 'border-box') {
            newHeight = newHeight - borderTopWidth - borderBottomWidth;
            newWidth = newWidth - borderLeftWidth - borderRightWidth;
          }

          if (
            (!disableHeight && _this.state.height !== newHeight) ||
            (!disableWidth && _this.state.width !== newWidth)
          ) {
            var state = {
              height: newHeight,
              width: newWidth
            };

            _this.setState(state);

            onResize(state);
          }
        }
      });

      _defineProperty(_assertThisInitialized(_this), '_setRef', function(autoSizer) {
        _this._autoSizer = autoSizer;
      });

      return _this;
    }

    _createClass(AutoSizer, [
      {
        key: 'componentDidMount',
        value: function componentDidMount() {
          var nonce = this.props.nonce;

          if (
            this._autoSizer &&
            this._autoSizer.parentNode &&
            this._autoSizer.parentNode.ownerDocument &&
            this._autoSizer.parentNode.ownerDocument.defaultView &&
            this._autoSizer.parentNode instanceof this._autoSizer.parentNode.ownerDocument.defaultView.HTMLElement
          ) {
            this._parentNode = this._autoSizer.parentNode;
            this._detectElementResize = (0, _detectElementResize['default'])(nonce);

            this._detectElementResize.addResizeListener(this._parentNode, this._onResize);

            this._onResize();
          }
        }
      },
      {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
          if (this._detectElementResize && this._parentNode) {
            this._detectElementResize.removeResizeListener(this._parentNode, this._onResize);
          }
        }
      },
      {
        key: 'render',
        value: function render() {
          var _this$props2 = this.props,
            children = _this$props2.children,
            className = _this$props2.className,
            disableHeight = _this$props2.disableHeight,
            disableWidth = _this$props2.disableWidth,
            style = _this$props2.style;
          var _this$state = this.state,
            height = _this$state.height,
            width = _this$state.width;
          var outerStyle = {
            overflow: 'visible'
          };
          var childParams = {};

          if (!disableHeight) {
            outerStyle.height = 0;
            childParams.height = height;
          }

          if (!disableWidth) {
            outerStyle.width = 0;
            childParams.width = width;
          }

          return _react['default'].createElement(
            'div',
            {
              className: className,
              ref: this._setRef,
              style: _objectSpread({}, outerStyle, {}, style, {
                minHeight: '100%'
              })
            },
            children(childParams)
          );
        }
      }
    ]);

    return AutoSizer;
  })(_react['default'].PureComponent);

exports['default'] = AutoSizer;

_defineProperty(AutoSizer, 'defaultProps', {
  onResize: function onResize() {},
  disableHeight: false,
  disableWidth: false,
  style: {}
});
