'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = void 0;

var _react = _interopRequireDefault(require('react'));

var _propTypes = _interopRequireDefault(require('prop-types'));

var _TableHeader = _interopRequireDefault(require('./TableHeader'));

var _TableRow = _interopRequireDefault(require('./TableRow'));

var _miniStore = require('./mini-store');

var _ExpandedIcon = _interopRequireDefault(require('./ExpandedIcon'));

var _TableCell = _interopRequireDefault(require('./TableCell'));

var _Select = _interopRequireDefault(require('./Select'));

var _types = require('./types');

var _utils = require('./utils');

function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : {default: obj};
}

function _typeof(obj) {
  '@babel/helpers - typeof';
  if (typeof Symbol === 'function' && typeof Symbol.iterator === 'symbol') {
    _typeof = function _typeof(obj) {
      return typeof obj;
    };
  } else {
    _typeof = function _typeof(obj) {
      return obj && typeof Symbol === 'function' && obj.constructor === Symbol && obj !== Symbol.prototype
        ? 'symbol'
        : typeof obj;
    };
  }
  return _typeof(obj);
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly)
      symbols = symbols.filter(function(sym) {
        return Object.getOwnPropertyDescriptor(object, sym).enumerable;
      });
    keys.push.apply(keys, symbols);
  }
  return keys;
}

function _objectSpread(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};
    if (i % 2) {
      ownKeys(Object(source), true).forEach(function(key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function(key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }
  return target;
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError('Cannot call a class as a function');
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ('value' in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _possibleConstructorReturn(self, call) {
  if (call && (_typeof(call) === 'object' || typeof call === 'function')) {
    return call;
  }
  return _assertThisInitialized(self);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf
    ? Object.getPrototypeOf
    : function _getPrototypeOf(o) {
        return o.__proto__ || Object.getPrototypeOf(o);
      };
  return _getPrototypeOf(o);
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }
  return self;
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== 'function' && superClass !== null) {
    throw new TypeError('Super expression must either be null or a function');
  }
  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {value: subClass, writable: true, configurable: true}
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf =
    Object.setPrototypeOf ||
    function _setPrototypeOf(o, p) {
      o.__proto__ = p;
      return o;
    };
  return _setPrototypeOf(o, p);
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {value: value, enumerable: true, configurable: true, writable: true});
  } else {
    obj[key] = value;
  }
  return obj;
}

var BaseTable =
  /*#__PURE__*/
  (function(_React$PureComponent) {
    _inherits(BaseTable, _React$PureComponent);

    function BaseTable() {
      var _getPrototypeOf2;

      var _this;

      _classCallCheck(this, BaseTable);

      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      _this = _possibleConstructorReturn(
        this,
        (_getPrototypeOf2 = _getPrototypeOf(BaseTable)).call.apply(_getPrototypeOf2, [this].concat(args))
      );

      _defineProperty(_assertThisInitialized(_this), '_children', []);

      _defineProperty(_assertThisInitialized(_this), '_startIndex', 0);

      _defineProperty(_assertThisInitialized(_this), '_stopIndex', 0);

      _defineProperty(_assertThisInitialized(_this), '_forceCount', 0);

      _defineProperty(_assertThisInitialized(_this), 'fExpanded', function(event) {
        event.stopPropagation();
        var expandChange = _this.context.expandChange;
        expandChange(event.currentTarget.getAttribute('data-key'));
      });

      _defineProperty(_assertThisInitialized(_this), 'fSort', function(key, order) {
        var sortManager = _this.context.manager.sortManager;
        var onSort = _this.context.props.onSort;
        sortManager.setOrder(key, order, function(orders) {
          _this.props.store.setState({
            orders: orders
          });

          if (typeof onSort === 'function') {
            onSort(orders, key, order);
          }
        });
      });

      _defineProperty(_assertThisInitialized(_this), 'getRowData', function(event) {
        var key = event.currentTarget.getAttribute('data-key');
        var dataManager = _this.context.manager.dataManager;
        return dataManager.getByKey(key) || {};
      });

      _defineProperty(_assertThisInitialized(_this), 'fEvents', function(event) {
        var record = _this.getRowData(event);

        var expandChange = _this.context.expandChange;
        var _this$context$props = _this.context.props,
          expandedRowByClick = _this$context$props.expandedRowByClick,
          onRow = _this$context$props.onRow;
        var events = onRow(record) || {};
        var func = _types.eventsMap[event.type];

        if ((0, _utils.has)(events, func) && typeof events[func] === 'function') {
          events[func](event);
        }

        if (event.type === 'click') {
          expandedRowByClick && record[_types.DS._expandedEnable] && expandChange(record[_types.DS._key]);
        } else if (event.type === 'mouseenter') {
          _this.fHover(true, record[_types.DS._key]);
        } else if (event.type === 'mouseleave') {
          _this.fHover(false, record[_types.DS._key]);
        }
      });

      _defineProperty(_assertThisInitialized(_this), 'fHover', function(isHover, key) {
        var hoverEnable = _this.context.props.hoverEnable;

        if (hoverEnable) {
          _this.props.store.setState({
            currentHoverKey: isHover ? key : null
          });
        }
      });

      _defineProperty(_assertThisInitialized(_this), 'fDrag', function(parent, columns) {
        var update = _this.context.update;
        var onHeaderSortable = _this.context.props.onHeaderSortable;
        var columnManager = _this.context.manager.columnManager;
        columnManager.updateGroupedColumns(_this.updateColumn(columnManager.groupedColumns(), parent, columns));
        _this._forceCount += 1;

        if (typeof update === 'function') {
          update();
        }

        if (typeof onHeaderSortable === 'function') {
          onHeaderSortable(columnManager.groupedColumns());
        }

        _this.forceUpdate();
      });

      _defineProperty(_assertThisInitialized(_this), 'updateColumn', function(columns, parent, newColumns) {
        columns = columns || [];

        if (!parent) {
          return newColumns;
        }

        return columns.map(function(column) {
          if (column[_types.CS._pathKey] === parent[_types.CS._pathKey]) {
            column = _objectSpread({}, column, {
              children: newColumns
            });
          } else {
            if (column.children && column.children.length > 0) {
              return _objectSpread({}, column, {
                children: _this.updateColumn(column.children, parent, newColumns)
              });
            }
          }

          return column;
        });
      });

      _defineProperty(_assertThisInitialized(_this), 'getCellStyle', function(column, record) {
        var onCell = column.onCell;
        var align = column.align || 'left';
        var width = column[_types.CS._width];

        var style = _objectSpread({}, (0, _utils.cellAlignStyle)(align));

        if (width) {
          style.width = width;
          style.minWidth = width;
        }

        if (onCell) {
          style = _objectSpread({}, style, {}, onCell(column, record));
        }

        return style;
      });

      _defineProperty(_assertThisInitialized(_this), 'getCellText', function(column, record) {
        var render = column.render,
          dataIndex = column.dataIndex;
        var text = (record || {})[dataIndex];

        if (typeof render === 'function') {
          text = render(text, record, record[_types.DS._index]);
        }

        if ((0, _utils.isInvalidRenderCellText)(text)) {
          text = null;
        }

        return text;
      });

      _defineProperty(_assertThisInitialized(_this), 'recomputeBody', function(_ref) {
        var startIndex = _ref.startIndex,
          stopIndex = _ref.stopIndex;
        var hasBody = _this.props.hasBody;

        if (hasBody) {
          _this._startIndex = startIndex;
          _this._stopIndex = stopIndex;
        }

        if (hasBody) {
          _this.renderRows(_this.props);
        }

        _this.forceUpdate();
      });

      _defineProperty(_assertThisInitialized(_this), 'getRowStyle', function(record, key) {
        var sizeManager = _this.context.manager.sizeManager;
        var rowStyle = {
          position: 'absolute',
          top: record[_types.DS._top],
          height: record[_types.DS._height],
          lineHeight: ''.concat(record[_types.DS._height] - 1, 'px')
        };

        if (record[_types.DS._isFixed] === true || record[_types.DS._isFixed] === 'top') {
          rowStyle.top += sizeManager._scrollTop;
          rowStyle.zIndex = 1;
        } else if (record[_types.DS._isFixed] === 'bottom') {
          if (sizeManager._hasScrollY) {
            rowStyle.top -=
              sizeManager._dataHeight +
              sizeManager.scrollSizeX() -
              sizeManager._scrollTop -
              sizeManager._clientBodyHeight;
          }

          rowStyle.zIndex = 1;
        }

        return rowStyle;
      });

      _defineProperty(_assertThisInitialized(_this), 'h_selectAll', function() {
        var _this$context$manager = _this.context.manager,
          selectManager = _this$context$manager.selectManager,
          dataManager = _this$context$manager.dataManager;
        var keys = selectManager.getKeys(dataManager.getData());
        selectManager.selectAll(keys);
      });

      _defineProperty(_assertThisInitialized(_this), 'r_selectAll', function() {
        var prefixCls = _this.context.props.prefixCls;
        var _this$context$manager2 = _this.context.manager,
          selectManager = _this$context$manager2.selectManager,
          dataManager = _this$context$manager2.dataManager;
        var keys = selectManager.getKeys(dataManager.getData());
        selectManager.count = keys.length;
        return (0, _Select['default'])({
          prefixCls: prefixCls,
          selected: selectManager.selectedAll,
          type: 'checkbox',
          onClick: _this.h_selectAll
        });
      });

      _defineProperty(_assertThisInitialized(_this), 'r_select', function(record) {
        var prefixCls = _this.context.props.prefixCls;
        var selectManager = _this.context.manager.selectManager;
        var selected = selectManager.selectedKeys.includes(record[_types.DS._key]);
        return (0, _Select['default'])({
          prefixCls: prefixCls,
          selected: selected,
          disabled: selectManager.disabled(record),
          type: selectManager.type,
          onClick: function onClick() {
            return selectManager.select(record, !selected);
          }
        });
      });

      _defineProperty(_assertThisInitialized(_this), 'renderCells', function(props, record) {
        var fixed = props.fixed;
        var _this$context$props2 = _this.context.props,
          prefixCls = _this$context$props2.prefixCls,
          indentSize = _this$context$props2.indentSize;
        var _this$context$manager3 = _this.context.manager,
          dataManager = _this$context$manager3.dataManager,
          columnManager = _this$context$manager3.columnManager,
          selectManager = _this$context$manager3.selectManager;
        var columns = columnManager.bodyColumns(fixed);
        var hasExpanded = dataManager._hasExpanded;
        var cells = [];

        for (var i = 0; i < columns.length; i++) {
          var cellKey = 'Row['
            .concat(record[_types.DS._path], ']-Col[')
            .concat(columns[i][_types.CS._pathKey], ']-')
            .concat(i, '_')
            .concat(fixed || '', '-')
            .concat(_this._forceCount);
          var cell = void 0;
          var cellProps = {
            key: cellKey,
            className: columns[i].className,
            style: _this.getCellStyle(columns[i], record)
          };

          if (hasExpanded && fixed !== 'right' && i === 0) {
            cellProps.ExpandedIcon = (0, _ExpandedIcon['default'])({
              prefixCls: prefixCls,
              indentSize: indentSize,
              record: record,
              onClick: _this.fExpanded
            });
          }

          if (selectManager.enable && fixed !== 'right' && i === 0) {
            cellProps.SelectIcon = _this.r_select(record, fixed);
          }

          cell = _react['default'].createElement(
            _TableCell['default'],
            cellProps,
            _this.getCellText(columns[i], record)
          );
          cells.push(cell);
        }

        return cells;
      });

      _defineProperty(_assertThisInitialized(_this), 'renderRowChildren', function(props, record) {
        var expandedRowRender = _this.context.props.expandedRowRender;

        if (expandedRowRender && record[_types.DS._expandedLevel] > 0) {
          return expandedRowRender(record, props.fixed, record[_types.DS._expandedLevel]);
        } else {
          return _this.renderCells(props, record);
        }
      });

      _defineProperty(_assertThisInitialized(_this), 'renderRows', function(props) {
        var rows = [];
        var fixed = props.fixed,
          currentHoverKey = props.currentHoverKey;
        var _this$context$props3 = _this.context.props,
          prefixCls = _this$context$props3.prefixCls,
          onRow = _this$context$props3.onRow;
        var dataManager = _this.context.manager.dataManager;
        var showData = dataManager.showData();
        var dataSource = showData.slice(_this._startIndex, _this._stopIndex);
        var fixedData = dataManager.getFixedData() || [];
        var top = undefined,
          bottom = undefined;
        fixedData.forEach(function(fd) {
          if (fd[_types.DS._isFixed] === true || fd[_types.DS._isFixed] === 'top') top = fd;
          if (fd[_types.DS._isFixed] === 'bottom' && bottom === undefined) bottom = fd;
        });
        dataSource = dataSource
          .filter(function(d) {
            return !dataManager.isFixed(d);
          })
          .concat(fixedData);

        var _loop = function _loop(index) {
          var record = dataSource[index];

          var cells = _this.renderRowChildren(props, record);

          var key = 'Row_'
            .concat(fixed || '', '_')
            .concat(record[_types.DS._path], '_')
            .concat(_this._forceCount);
          var rowProps = {
            key: key,
            prefixCls: prefixCls,
            cells: cells,
            record: record,
            hovered: currentHoverKey === record[_types.DS._key],
            style: _this.getRowStyle(record, key)
          };
          if (top === record) rowProps.isTop = true;
          if (bottom === record) rowProps.isBottom = true;
          (0, _utils.keys)(onRow(record) || {}, record[_types.DS._index]).forEach(function(event) {
            return (rowProps[event] = _this.fEvents);
          });
          ['onClick', 'onMouseEnter', 'onMouseLeave'].forEach(function(event) {
            if (!(0, _utils.has)(onRow(record), event)) {
              rowProps[event] = _this.fEvents;
            }
          });
          rows.push(_react['default'].createElement(_TableRow['default'], rowProps, cells));
        };

        for (var index = 0; index < dataSource.length; index++) {
          _loop(index);
        }

        _this._children = rows;
        return _this._children;
      });

      _defineProperty(_assertThisInitialized(_this), 'r_header', function() {
        var _this$props = _this.props,
          hasHead = _this$props.hasHead,
          fixed = _this$props.fixed,
          orders = _this$props.orders;
        var _this$context$manager4 = _this.context.manager,
          columnManager = _this$context$manager4.columnManager,
          selectManager = _this$context$manager4.selectManager;
        var _this$context$props4 = _this.context.props,
          prefixCls = _this$context$props4.prefixCls,
          headerRowHeight = _this$context$props4.headerRowHeight,
          onHeaderRow = _this$context$props4.onHeaderRow;
        if (!hasHead) return null;
        var props = {
          columns: columnManager.headColumns(fixed),
          fixed: fixed,
          onSort: _this.fSort,
          orders: orders,
          prefixCls: prefixCls,
          headerRowHeight: headerRowHeight,
          onHeaderRow: onHeaderRow,
          onDrag: _this.fDrag
        };

        if (selectManager.useSelectAll) {
          props.SelectIcon = _this.r_selectAll();
          props.selectedAll = selectManager.selectedAll;
        }

        return (0, _TableHeader['default'])(props);
      });

      return _this;
    }

    _createClass(BaseTable, [
      {
        key: 'componentWillMount',
        value: function componentWillMount() {
          this.start = new Date().getTime();
          this._forceCount = 0;
          var _this$props2 = this.props,
            registerForce = _this$props2.registerForce,
            fixed = _this$props2.fixed,
            hasHead = _this$props2.hasHead,
            hasBody = _this$props2.hasBody;
          var sizeManager = this.context.manager.sizeManager;

          if (registerForce) {
            var name = fixed;

            if (hasHead) {
              name += '-head';
            }

            if (hasBody) {
              name += '-body';
            }

            registerForce(name, this.recomputeBody);
          }

          this._startIndex = sizeManager._startIndex;
          this._stopIndex = sizeManager._stopIndex;
          this.renderRows(this.props);
        }
      },
      {
        key: 'componentWillUpdate',
        value: function componentWillUpdate(np) {
          if (np.hasBody) this.renderRows(np);
        }
      },
      {
        key: 'render',
        value: function render() {
          var _this$props3 = this.props,
            hasBody = _this$props3.hasBody,
            fixed = _this$props3.fixed;
          var _this$context$manager5 = this.context.manager,
            columnManager = _this$context$manager5.columnManager,
            sizeManager = _this$context$manager5.sizeManager;
          var rowHeight = this.context.props.rowHeight;
          var body;

          if (hasBody) {
            body = _react['default'].createElement(
              'div',
              {
                className: 'tbody',
                style: {
                  height: sizeManager._dataHeight,
                  minHeight: rowHeight
                }
              },
              this._children
            );
          }

          var width = columnManager.getWidth(fixed) || '100%';
          var style = {
            width: width
          };

          if (!fixed) {
            style.minWidth = '100%';
          }

          var header = this.r_header();
          return _react['default'].createElement(
            'div',
            {
              className: 'table',
              style: style
            },
            header,
            body
          );
        }
      }
    ]);

    return BaseTable;
  })(_react['default'].PureComponent);

_defineProperty(BaseTable, 'contextTypes', {
  props: _propTypes['default'].object,
  manager: _propTypes['default'].object,
  expandChange: _propTypes['default'].func,
  update: _propTypes['default'].func
});

var _default = (0, _miniStore.connect)(function(state) {
  var currentHoverKey = state.currentHoverKey,
    orders = state.orders;
  return {
    // currentHoverKey,
    orders: orders
  };
})(BaseTable);

exports['default'] = _default;
