'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = void 0;

var _react = _interopRequireDefault(require('react'));

var _propTypes = _interopRequireDefault(require('prop-types'));

var _BaseTable = _interopRequireDefault(require('./BaseTable'));

function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : {default: obj};
}

function HeadTable(props, _ref) {
  var manager = _ref.manager,
    baseProps = _ref.props;
  var fixedHeader = baseProps.fixedHeader,
    prefixCls = baseProps.prefixCls,
    showHeader = baseProps.showHeader;
  var saveRef = props.saveRef,
    fixed = props.fixed,
    registerForce = props.registerForce;
  var sizeManager = manager.sizeManager,
    columnManager = manager.columnManager;
  var headStyle = {};

  if (fixedHeader && showHeader) {
    var scrollbarWidth = sizeManager.scrollSizeX();

    if (scrollbarWidth > 0 && !fixed) {
      headStyle.marginBottom = '-'.concat(scrollbarWidth, 'px');
      headStyle.paddingBottom = '0px';
    }

    if (!sizeManager._hasScrollX) {
      headStyle.overflowX = 'hidden';
    }

    headStyle.overflowY = sizeManager._hasScrollY ? 'scroll' : 'hidden';
    return _react['default'].createElement(
      'div',
      {
        key: 'headTable',
        className: ''.concat(prefixCls, '-header'),
        style: headStyle,
        ref: fixed ? null : saveRef('headTable')
      },
      _react['default'].createElement(_BaseTable['default'], {
        hasHead: true,
        hasBody: false,
        fixed: fixed,
        registerForce: registerForce,
        columns: columnManager.headColumns(fixed)
      })
    );
  }

  return null;
}

var _default = HeadTable;
exports['default'] = _default;
HeadTable.contextTypes = {
  props: _propTypes['default'].object,
  manager: _propTypes['default'].object
};
