'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = Select;

var _react = _interopRequireDefault(require('react'));

var _classnames = _interopRequireDefault(require('classnames'));

var _Icon = _interopRequireDefault(require('./Icon'));

function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : {default: obj};
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {value: value, enumerable: true, configurable: true, writable: true});
  } else {
    obj[key] = value;
  }
  return obj;
}

function Select(props) {
  var prefixCls = props.prefixCls,
    selected = props.selected,
    onClick = props.onClick,
    type = props.type,
    disabled = props.disabled;
  var cls = (0, _classnames['default'])(
    ''.concat(prefixCls, '-select'),
    ''.concat(prefixCls, '-select-').concat(type),
    _defineProperty(
      {
        selected: selected
      },
      ''.concat(prefixCls, '-select-disabled'),
      disabled
    )
  );
  var children = null;

  if (selected) {
    children = _react['default'].createElement(_Icon['default'], {
      type: type
    });
  }

  function click(event) {
    event.stopPropagation();

    if (!disabled) {
      onClick(event);
    }
  }

  return _react['default'].createElement(
    'div',
    {
      style: {
        display: 'inline-block',
        textAlign: 'left',
        verticalAlign: 'middle'
      },
      onClick: click
    },
    _react['default'].createElement(
      'span',
      {
        className: cls
      },
      children
    )
  );
}
