'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = void 0;

var _react = _interopRequireDefault(require('react'));

var _propTypes = _interopRequireDefault(require('prop-types'));

var _reactDom = require('react-dom');

function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : {default: obj};
}

function _typeof(obj) {
  '@babel/helpers - typeof';
  if (typeof Symbol === 'function' && typeof Symbol.iterator === 'symbol') {
    _typeof = function _typeof(obj) {
      return typeof obj;
    };
  } else {
    _typeof = function _typeof(obj) {
      return obj && typeof Symbol === 'function' && obj.constructor === Symbol && obj !== Symbol.prototype
        ? 'symbol'
        : typeof obj;
    };
  }
  return _typeof(obj);
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread();
}

function _nonIterableSpread() {
  throw new TypeError('Invalid attempt to spread non-iterable instance');
}

function _iterableToArray(iter) {
  if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === '[object Arguments]')
    return Array.from(iter);
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) {
      arr2[i] = arr[i];
    }
    return arr2;
  }
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError('Cannot call a class as a function');
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ('value' in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _possibleConstructorReturn(self, call) {
  if (call && (_typeof(call) === 'object' || typeof call === 'function')) {
    return call;
  }
  return _assertThisInitialized(self);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf
    ? Object.getPrototypeOf
    : function _getPrototypeOf(o) {
        return o.__proto__ || Object.getPrototypeOf(o);
      };
  return _getPrototypeOf(o);
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }
  return self;
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== 'function' && superClass !== null) {
    throw new TypeError('Super expression must either be null or a function');
  }
  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {value: subClass, writable: true, configurable: true}
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf =
    Object.setPrototypeOf ||
    function _setPrototypeOf(o, p) {
      o.__proto__ = p;
      return o;
    };
  return _setPrototypeOf(o, p);
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {value: value, enumerable: true, configurable: true, writable: true});
  } else {
    obj[key] = value;
  }
  return obj;
}

var Children = _react['default'].Children,
  PureComponent = _react['default'].PureComponent;

var Sortable =
  /*#__PURE__*/
  (function(_PureComponent) {
    _inherits(Sortable, _PureComponent);

    function Sortable(_props) {
      var _this;

      _classCallCheck(this, Sortable);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(Sortable).call(this, _props));

      _defineProperty(_assertThisInitialized(_this), 'currentEl', null);

      _defineProperty(_assertThisInitialized(_this), 'cloneEl', null);

      _defineProperty(_assertThisInitialized(_this), 'parentEl', null);

      _defineProperty(_assertThisInitialized(_this), 'dragAble', false);

      _defineProperty(_assertThisInitialized(_this), 'offsetX', 0);

      _defineProperty(_assertThisInitialized(_this), 'currentElIndex', null);

      _defineProperty(_assertThisInitialized(_this), 'prevEl', null);

      _defineProperty(_assertThisInitialized(_this), 'nextEl', null);

      _defineProperty(_assertThisInitialized(_this), 'propsToState', function() {
        var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.props;
        var showIndex = [];
        var children = Children.map(props.children, function(child, index) {
          showIndex.push(index);

          if (child.props.fixed === 'left') {
            _this.fixedIndex.push(index);

            _this.leftFixedIndex.push(index);
          }

          if (child.props.fixed === 'right') {
            _this.fixedIndex.push(index);

            _this.rightFixedIndex.push(index);
          }

          return _react['default'].cloneElement(child, {
            ref: _this.saveRef(index),
            onMouseDown: _this.handleMouseDown,
            'data-index': index
          });
        });
        _this.backIndex = showIndex;
        return {
          showIndex: showIndex,
          children: children
        };
      });

      _defineProperty(_assertThisInitialized(_this), 'saveRef', function(index) {
        return function(node) {
          _this['child-'.concat(index)] = node;
        };
      });

      _defineProperty(_assertThisInitialized(_this), 'handleMouseMove', function(event) {
        if (_this.dragAble) {
          var left = event.pageX - _this.offsetX;
          left = left < 0 ? 0 : left;
          _this.cloneEl.style.left = ''.concat(left, 'px');

          _this._swap();
        } else {
          return event;
        }
      });

      _defineProperty(_assertThisInitialized(_this), 'handleMouseUp', function(event) {
        var _this$props = _this.props,
          onDrag = _this$props.onDrag,
          parent = _this$props.parent,
          columns = _this$props.columns;

        if (!_this.dragAble) {
          return event;
        }

        _this.dragAble = false;

        if (_this.cloneEl && _this.parentEl) {
          _this.parentEl.removeChild(_this.cloneEl);

          _this.parentEl = null;
          _this.cloneEl = null;
          _this.currentEl.style.opacity = 1;
          _this.currentEl.style.background = 'transparent';
          _this.currentEl = null;
          _this.currentElIndex = null;
          _this.prevEl = null;
          _this.nextEl = null;
          _this.dataCurrentIndex = null;
          _this.prevElIndex = null;
          _this.nextElIndex = null;
        }

        document.body.style['user-select'] = 'text';
        document.body.style['-ms-user-select'] = 'text';
        document.body.style['-moz-user-select'] = 'text';
        document.body.style['-webkit-user-select'] = 'text';

        var dragChange = _this.state.showIndex.some(function(index, i) {
          return _this.backIndex[i] !== index;
        });

        if (dragChange && typeof onDrag === 'function') {
          onDrag(
            parent,
            _this.state.showIndex.map(function(index) {
              return columns[index];
            })
          );
        }
      });

      _defineProperty(_assertThisInitialized(_this), 'handleMouseDown', function(event) {
        var headerSortable = _this.context.getProps('headerSortable');

        if (event.button !== 0) {
          return event;
        }

        if (!headerSortable) {
          return event;
        }

        _this.backIndex = _this.state.showIndex;
        document.body.style['user-select'] = 'none';
        document.body.style['-ms-user-select'] = 'none';
        document.body.style['-moz-user-select'] = 'none';
        document.body.style['-webkit-user-select'] = 'none';
        _this.parentEl = event.currentTarget.parentNode;
        _this.cloneEl = event.currentTarget.cloneNode(true);
        _this.currentEl = event.currentTarget;
        _this.currentEl.style.opacity = 0; // get current index

        var index = _this.currentEl.getAttribute('data-index');

        _this.dataCurrentIndex = Number(index);

        _this._both(); // clone current element

        var currentRect = _this.currentEl.getBoundingClientRect();

        var parentRect = _this.parentEl.getBoundingClientRect();

        _this.cloneEl.style.position = 'absolute';
        _this.cloneEl.style.zIndex = 9999;
        _this.cloneEl.style.background = '#393939';
        _this.cloneEl.style.opacity = 0.8;
        _this.cloneEl.style.left = ''.concat(currentRect.left - (parentRect.left > 0 ? parentRect.left : 0), 'px');
        _this.cloneEl.style.boxShadow = '0 0 10px rgba(0, 0, 0, .4)';
        _this.offsetX = event.pageX - currentRect.left + (parentRect.left > 0 ? parentRect.left : 0); // calc left max and min

        var left = 0;

        if (_this.leftFixedIndex > 0) {
          _this.leftFixedIndex.forEach(function(i) {
            var ele = (0, _reactDom.findDOMNode)(_this['child-'.concat(i)]).getBoundingClientRect();
            left = left > ele.left + ele.width ? left : ele.left + ele.width;
          });
        }

        _this.parentEl.appendChild(_this.cloneEl);

        _this.dragAble = true;
        event.stopPropagation();
      });

      _defineProperty(_assertThisInitialized(_this), '_swap', function() {
        var cloneRect = _this.cloneEl.getBoundingClientRect();

        var nextRect, prevRect;

        if (_this.nextEl) {
          nextRect = _this.nextEl.getBoundingClientRect();

          if (cloneRect.left + cloneRect.width > nextRect.left + nextRect.width / 2) {
            // next swap
            var showIndex = _toConsumableArray(_this.state.showIndex);

            var temp = showIndex[_this.currentElIndex];
            showIndex[_this.currentElIndex] = showIndex[_this.nextElIndex];
            showIndex[_this.nextElIndex] = temp;

            _this.setState(
              {
                showIndex: showIndex
              },
              _this._both
            );
          }
        }

        if (_this.prevEl) {
          prevRect = _this.prevEl.getBoundingClientRect();

          if (cloneRect.left < prevRect.left + prevRect.width / 2) {
            // prev swap
            var _showIndex = _toConsumableArray(_this.state.showIndex);

            var _temp = _showIndex[_this.currentElIndex];
            _showIndex[_this.currentElIndex] = _showIndex[_this.prevElIndex];
            _showIndex[_this.prevElIndex] = _temp;

            _this.setState(
              {
                showIndex: _showIndex
              },
              _this._both
            );
          }
        }
      });

      _defineProperty(_assertThisInitialized(_this), '_both', function() {
        var showIndex = _this.state.showIndex;
        _this.currentElIndex = showIndex.indexOf(_this.dataCurrentIndex);
        _this.prevElIndex = _this.currentElIndex - 1;
        _this.nextElIndex = _this.currentElIndex + 1;
        _this.prevEl = null;
        _this.nextEl = null;

        if (
          _this.prevElIndex >= 0 &&
          (_this.fixedIndex.length === 0 ||
            !_this.fixedIndex.some(function(i) {
              return i === _this.prevElIndex;
            }))
        ) {
          // enable drag prev
          _this.prevEl = (0, _reactDom.findDOMNode)(_this['child-'.concat(showIndex[_this.prevElIndex])]);
        }

        if (
          _this.nextElIndex < showIndex.length &&
          (_this.fixedIndex.length === 0 ||
            !_this.fixedIndex.some(function(i) {
              return i === _this.nextElIndex;
            }))
        ) {
          //enable drag next
          _this.nextEl = (0, _reactDom.findDOMNode)(_this['child-'.concat(showIndex[_this.nextElIndex])]);
        }
      });

      _this.fixedIndex = [];
      _this.leftFixedIndex = [];
      _this.rightFixedIndex = [];
      _this.state = _this.propsToState();
      return _this;
    }

    _createClass(Sortable, [
      {
        key: 'componentDidMount',
        value: function componentDidMount() {
          document.addEventListener('mousemove', this.handleMouseMove);
          document.addEventListener('mouseup', this.handleMouseUp);
        }
      },
      {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
          if (nextProps.children !== this.props.children) {
            this.setState(this.propsToState(nextProps));
          }
        }
      },
      {
        key: 'render',
        value: function render() {
          var _this$state = this.state,
            showIndex = _this$state.showIndex,
            children = _this$state.children;
          return showIndex.map(function(i) {
            return children[i];
          });
        }
      }
    ]);

    return Sortable;
  })(PureComponent);

_defineProperty(Sortable, 'contextTypes', {
  props: _propTypes['default'].object,
  updateScrollLeft: _propTypes['default'].func,
  getProps: _propTypes['default'].func
});

var _default = Sortable;
exports['default'] = _default;
