'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = void 0;

var _react = _interopRequireDefault(require('react'));

var _classnames = _interopRequireDefault(require('classnames'));

function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : {default: obj};
}

var Order = {
  desc: 'desc',
  asc: 'asc'
};

function Sorter(props) {
  var onSort = props.onSort,
    dataIndex = props.dataIndex,
    prefixCls = props.prefixCls;
  var order = props.order;

  if (order === true) {
    order = 'desc';
  }

  var path =
    'M556.8 876.8l134.4-134.4c25.6-25.6 25.6-64 0-89.6-25.6-25.6-64-25.6-89.6 0L576 678.4 576 192c0-38.4-25.6-64-64-64S448 153.6 448 192l0 486.4-25.6-25.6c-25.6-25.6-64-25.6-89.6 0-25.6 25.6-25.6 64 0 89.6l134.4 134.4C492.8 902.4 531.2 902.4 556.8 876.8z';

  if (order === 'asc') {
    path =
      'M467.2 147.2 332.8 281.6c-25.6 25.6-25.6 64 0 89.6 25.6 25.6 64 25.6 89.6 0L448 345.6 448 832c0 38.4 25.6 64 64 64s64-25.6 64-64L576 345.6l25.6 25.6c25.6 25.6 64 25.6 89.6 0 25.6-25.6 25.6-64 0-89.6L556.8 147.2C531.2 121.6 492.8 121.6 467.2 147.2z';
  }

  var onClick = function onClick() {
    var o = order === Order.desc ? Order.asc : Order.desc;

    if (typeof onSort === 'function') {
      onSort(dataIndex, o);
    }
  };

  var wrapperCls = ''.concat(prefixCls, '-sorter');
  return _react['default'].createElement(
    'div',
    {
      className: wrapperCls,
      onClick: onClick
    },
    _react['default'].createElement(
      'svg',
      {
        viewBox: '64 64 896 896',
        className: '',
        'data-icon': 'plus',
        width: '1em',
        height: '1em',
        fill: 'currentColor',
        'aria-hidden': 'true',
        focusable: 'false',
        style: {
          display: 'inline-block'
        }
      },
      _react['default'].createElement('path', {
        d: path
      })
    )
  );
}

var _default = Sorter;
exports['default'] = _default;
