'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = void 0;

var _react = _interopRequireDefault(require('react'));

var _HeadCell = _interopRequireDefault(require('./HeadCell'));

var _Sortable = _interopRequireDefault(require('./Sortable'));

function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : {default: obj};
}

function TableHeader(props) {
  var columns = props.columns,
    orders = props.orders,
    onSort = props.onSort,
    fixed = props.fixed,
    headerRowHeight = props.headerRowHeight,
    prefixCls = props.prefixCls,
    onHeaderRow = props.onHeaderRow,
    onDrag = props.onDrag,
    SelectIcon = props.SelectIcon;
  var children = columns.map(function(column, index) {
    return (0, _HeadCell['default'])({
      key: 'HeadCol'.concat(index),
      column: column,
      prefixCls: prefixCls,
      headerRowHeight: headerRowHeight,
      orders: orders,
      onSort: onSort,
      fixed: column.fixed,
      onHeaderRow: onHeaderRow,
      onDrag: onDrag,
      SelectIcon: index === 0 && fixed !== 'right' && SelectIcon ? SelectIcon : null
    });
  });

  if (!fixed) {
    children = _react['default'].createElement(
      _Sortable['default'],
      {
        columns: columns,
        onDrag: onDrag
      },
      children
    );
  }

  return _react['default'].createElement(
    'div',
    {
      className: 'thead'
    },
    _react['default'].createElement(
      'div',
      {
        className: 'tr'
      },
      children
    )
  );
}

var _default = TableHeader;
exports['default'] = _default;
