'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = void 0;

var _react = _interopRequireDefault(require('react'));

var _classnames = _interopRequireDefault(require('classnames'));

var _types = require('./types');

function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : {default: obj};
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {value: value, enumerable: true, configurable: true, writable: true});
  } else {
    obj[key] = value;
  }
  return obj;
}

function Row(props) {
  var _classNames;

  var prefixCls = props.prefixCls,
    hovered = props.hovered,
    children = props.children,
    style = props.style,
    record = props.record,
    isTop = props.isTop,
    isBottom = props.isBottom;
  var rowClass = (0, _classnames['default'])(
    record[_types.DS._rowClassName],
    ((_classNames = {}),
    _defineProperty(_classNames, ''.concat(prefixCls, '-hover'), hovered),
    _defineProperty(_classNames, ''.concat(prefixCls, '-fixed-top'), !!isTop),
    _defineProperty(_classNames, ''.concat(prefixCls, '-fixed-bottom'), !!isBottom),
    _classNames)
  );
  var newProps = {
    className: rowClass,
    style: style,
    'data-key': record[_types.DS._key]
  };

  _types.rowEvents.forEach(function(event) {
    if (typeof props[event] === 'function') {
      newProps[event] = props[event];
    }
  });

  return _react['default'].createElement('div', newProps, children);
}

var _default = Row;
exports['default'] = _default;
