'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = void 0;

var _react = _interopRequireDefault(require('react'));

var _propTypes = _interopRequireDefault(require('prop-types'));

var _classnames = _interopRequireDefault(require('classnames'));

var _floor = _interopRequireDefault(require('lodash/floor'));

var _ceil = _interopRequireDefault(require('lodash/ceil'));

var _shallowequal = _interopRequireDefault(require('shallowequal'));

var _componentClasses = _interopRequireDefault(require('component-classes'));

var _HeadTable = _interopRequireDefault(require('./HeadTable'));

var _BodyTable = _interopRequireDefault(require('./BodyTable'));

var _ColumnManager = _interopRequireDefault(require('./managers/ColumnManager'));

var _DataManager = _interopRequireDefault(require('./managers/DataManager'));

var _SortManager = _interopRequireDefault(require('./managers/SortManager'));

var _SizeManager = _interopRequireDefault(require('./managers/SizeManager'));

var _SelectManager = _interopRequireDefault(require('./managers/SelectManager'));

var _AutoSizer = _interopRequireDefault(require('./AutoSizer'));

var _miniStore = require('./mini-store');

var _types = require('./types');

var _utils = require('./utils');

require('../theme/table.css');

function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : {default: obj};
}

function _typeof(obj) {
  '@babel/helpers - typeof';
  if (typeof Symbol === 'function' && typeof Symbol.iterator === 'symbol') {
    _typeof = function _typeof(obj) {
      return typeof obj;
    };
  } else {
    _typeof = function _typeof(obj) {
      return obj && typeof Symbol === 'function' && obj.constructor === Symbol && obj !== Symbol.prototype
        ? 'symbol'
        : typeof obj;
    };
  }
  return _typeof(obj);
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly)
      symbols = symbols.filter(function(sym) {
        return Object.getOwnPropertyDescriptor(object, sym).enumerable;
      });
    keys.push.apply(keys, symbols);
  }
  return keys;
}

function _objectSpread(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};
    if (i % 2) {
      ownKeys(Object(source), true).forEach(function(key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function(key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }
  return target;
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError('Cannot call a class as a function');
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ('value' in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _possibleConstructorReturn(self, call) {
  if (call && (_typeof(call) === 'object' || typeof call === 'function')) {
    return call;
  }
  return _assertThisInitialized(self);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf
    ? Object.getPrototypeOf
    : function _getPrototypeOf(o) {
        return o.__proto__ || Object.getPrototypeOf(o);
      };
  return _getPrototypeOf(o);
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }
  return self;
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== 'function' && superClass !== null) {
    throw new TypeError('Super expression must either be null or a function');
  }
  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {value: subClass, writable: true, configurable: true}
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf =
    Object.setPrototypeOf ||
    function _setPrototypeOf(o, p) {
      o.__proto__ = p;
      return o;
    };
  return _setPrototypeOf(o, p);
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {value: value, enumerable: true, configurable: true, writable: true});
  } else {
    obj[key] = value;
  }
  return obj;
}

var Table =
  /*#__PURE__*/
  (function(_React$PureComponent) {
    _inherits(Table, _React$PureComponent);

    function Table(props) {
      var _this;

      _classCallCheck(this, Table);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(Table).call(this, props));

      _defineProperty(_assertThisInitialized(_this), '_forceTable', {});

      _defineProperty(_assertThisInitialized(_this), '_renderEnable', false);

      _defineProperty(_assertThisInitialized(_this), 'state', {
        width: 0,
        height: 0
      });

      _defineProperty(_assertThisInitialized(_this), 'getProps', function(prop) {
        return _this.props[prop];
      });

      _defineProperty(_assertThisInitialized(_this), 'getShowCount', function() {
        var showHeader = _this.props.showHeader;

        var dataSource = _this.dataManager.showData();

        var count = _this.showCount;

        if (!_this.sizeManager.useScrollY) {
          _this.showCount = (dataSource || []).length;
          return;
        }

        var _height = _this._height || 0;

        if (showHeader) {
          _height -= _this.sizeManager._headerHeight;
          _height = Math.max(_height, 0);
        }

        _this.showCount = Math.min((0, _ceil['default'])(_height / _this.props.rowHeight), dataSource.length);
        return count !== _this.showCount;
      });

      _defineProperty(_assertThisInitialized(_this), 'onResize', function(_ref) {
        var width = _ref.width,
          height = _ref.height;

        if (_this._width !== width || _this._height !== height) {
          _this._renderEnable = true;
          _this._width = width;
          _this._height = height;

          _this.sizeManager.update({
            _wrapperWidth: width,
            _wrapperHeight: height,
            _scrollSizeX: (0, _utils.measureScrollbar)('horizontal'),
            _scrollSizeY: (0, _utils.measureScrollbar)()
          });

          var change = _this.getShowCount();

          _this.updateColumn();

          _this.resetShowData();

          if (change) {
            _this.forceUpdate();
          }
        }
      });

      _defineProperty(_assertThisInitialized(_this), 'updateColumn', function() {
        if (_this.sizeManager._wrapperWidth > 0) {
          var cWidth = _this.sizeManager._wrapperWidth - _this.sizeManager.scrollSizeY();

          _this.sizeManager.update(_this.columnManager.updateWidth(cWidth));
        }
      });

      _defineProperty(_assertThisInitialized(_this), 'setPositionClass', function(tg) {
        var target = tg;

        if (!target) {
          target = _this['bodyTable'];
        }

        if (!target) return;
        var left = target.scrollLeft;
        var top = target.scrollTop;
        var clientWidth = target.clientWidth;
        var clientHeight = target.clientHeight;
        var scrollHeight = target.scrollHeight;
        var scrollWidth = target.scrollWidth;
        var position = {};
        var xp;

        if (!_this.sizeManager._hasScrollX) {
          xp = 'clear';
        } else {
          if (left === 0) {
            xp = 'x-left';
          } else if (left + clientWidth < scrollWidth) {
            xp = 'x-middle';
          } else if (left + clientWidth === scrollWidth) {
            xp = 'x-right';
          }
        }

        if (xp) position.xp = xp;
        var yp;

        if (!_this.sizeManager._hasScrollY) {
          yp = 'clear';
        } else {
          if (top === 0) {
            yp = 'y-top';
          } else if (top + clientHeight < scrollHeight) {
            yp = 'y-middle';
          } else if (top + clientHeight === scrollHeight) {
            yp = 'y-bottom';
          }
        }

        if (yp) position.yp = yp;

        if (_this.position.xp !== position.xp || _this.position.yp !== position.yp) {
          _this.position = position;

          var _assertThisInitialize = _assertThisInitialized(_this),
            tableNode = _assertThisInitialize.tableNode;

          if (tableNode) {
            var prefixCls = _this.props.prefixCls;
            var cs = (0, _componentClasses['default'])(tableNode);

            if (position.xp) {
              cs.remove(new RegExp('^'.concat(prefixCls, '-scroll-position-x-.+$')));
              position.xp !== 'clear' && cs.add(''.concat(prefixCls, '-scroll-position-').concat(position.xp));
            }

            if (position.yp) {
              cs.remove(new RegExp('^'.concat(prefixCls, '-scroll-position-y-.+$')));
              position.yp !== 'clear' && cs.add(''.concat(prefixCls, '-scroll-position-').concat(position.yp));
            }
          }
        }
      });

      _defineProperty(_assertThisInitialized(_this), 'handleBodyScroll', function(e) {
        var onScroll = _this.props.onScroll;

        _this.handleBodyScrollLeft(e);

        _this.handleBodyScrollTop(e);

        if (typeof onScroll === 'function') {
          onScroll(e);
        }

        if (e.target !== e.currentTarget) {
          return;
        }

        _this.setPositionClass(e.target);
      });

      _defineProperty(_assertThisInitialized(_this), 'handleBodyScrollLeft', function(e) {
        if (e.currentTarget !== e.target) {
          return;
        }

        var target = e.target;

        var _assertThisInitialize2 = _assertThisInitialized(_this),
          headTable = _assertThisInitialize2.headTable,
          bodyTable = _assertThisInitialize2.bodyTable;

        if (target.scrollLeft !== _this.lastScrollLeft) {
          if (target === bodyTable && headTable) {
            headTable.scrollLeft = target.scrollLeft;
          } // this.setScrollPositionClassName();
        }

        _this.lastScrollLeft = target.scrollLeft;

        _this.sizeManager.update({
          _scrollLeft: _this.lastScrollLeft
        });
      });

      _defineProperty(_assertThisInitialized(_this), 'updateScrollLeft', function(scrollLeft) {
        var _assertThisInitialize3 = _assertThisInitialized(_this),
          headTable = _assertThisInitialize3.headTable,
          bodyTable = _assertThisInitialize3.bodyTable;

        if (!bodyTable || bodyTable.scrollHeight === 0) {
          return;
        }

        if (_this.lastScrollLeft !== scrollLeft) {
          if (headTable) {
            headTable.scrollLeft = scrollLeft;
          }

          if (bodyTable) {
            bodyTable.scrollLeft = scrollLeft;
          } // this.setScrollPositionClassName();

          _this.setPositionClass();
        }

        _this.lastScrollLeft = scrollLeft;

        _this.sizeManager.update({
          _scrollLeft: _this.lastScrollLeft
        });
      });

      _defineProperty(_assertThisInitialized(_this), 'updateScrollTop', function(target) {
        ['bodyTable', 'fixedColumnsBodyLeft', 'fixedColumnsBodyRight'].forEach(function(node) {
          if (_this[node] && target !== _this[node]) {
            _this[node].scrollTop = target.scrollTop;
          }
        });
      });

      _defineProperty(_assertThisInitialized(_this), 'updateScrollTopEnable', function(nextProps) {});

      _defineProperty(_assertThisInitialized(_this), 'handleBodyScrollTop', function(e) {
        var target = e.target;

        if (target !== e.currentTarget) {
          return;
        }

        var _assertThisInitialize4 = _assertThisInitialized(_this),
          headTable = _assertThisInitialize4.headTable;

        if (_this.lastScrollTop !== target.scrollTop && target !== headTable) {
          _this.lastScrollTop = target.scrollTop;

          _this.updateScrollTop(target);

          _this.sizeManager.update({
            _scrollTop: target.scrollTop
          });

          _this.resetShowData(target);

          if (_this.props.refreshEnable) {
            _this.scrollRefresh(target);
          }
        }
      });

      _defineProperty(_assertThisInitialized(_this), 'scrollRefresh', function(target) {
        var _this$props = _this.props,
          scrollEndPosition = _this$props.scrollEndPosition,
          onScrollEnd = _this$props.onScrollEnd;

        if (target.scrollTop + target.clientHeight + scrollEndPosition > target.scrollHeight && _this.refreshAble) {
          if (typeof onScrollEnd === 'function') {
            onScrollEnd();
            _this.refreshAble = false;
          }
        } else {
          _this.refreshAble = true;
        }
      });

      _defineProperty(_assertThisInitialized(_this), 'skipIndex', function() {
        var dataSource = _this.dataManager.showData() || [];

        if (_this.sizeManager._showStartIndex > 0 && dataSource.length > 0) {
          var state = {};
          state.startIndex = _this.sizeManager._showStartIndex;
          state.stopIndex = state.startIndex + _this.showCount + 2;

          if (state.stopIndex > dataSource.length - 1) {
            state.stopIndex = dataSource.length - 1;
            state.startIndex = state.stopIndex - _this.showCount - 2;
          }

          _this.lastScrollTop = dataSource[state.startIndex][_types.DS._top];

          _this.updateScrollTop({
            scrollTop: dataSource[state.startIndex][_types.DS._top]
          });

          _this.sizeManager.update({
            _startIndex: state.startIndex,
            _stopIndex: state.stopIndex,
            _showStartIndex: 0,
            _scrollTop: dataSource[state.startIndex][_types.DS._top]
          });

          for (var key in _this._forceTable) {
            if (_this._forceTable.hasOwnProperty(key) && _this._forceTable[key]) {
              _this._forceTable[key](state);
            }
          }
        }
      });

      _defineProperty(_assertThisInitialized(_this), 'resetShowData', function(target) {
        if (target) {
          _this.sizeManager.update({
            _scrollTop: target.scrollTop
          });
        }

        var scrollTop = _this.sizeManager._scrollTop;
        var rowHeight = _this.props.rowHeight;
        var dataSource = _this.dataManager.showData() || [];
        var state = {};

        if (_this._height === 0) {
          state.startIndex = 0;
          state.stopIndex = 0;
        } else if (!_this.sizeManager._hasScrollY || !_this.sizeManager.useScrollY) {
          state.startIndex = 0;
          state.stopIndex = dataSource.length;
        } else {
          var startIndex = (0, _floor['default'])(scrollTop / rowHeight) - 1;

          for (var i = 0; i < dataSource.length; i++) {
            if (scrollTop < dataSource[i][_types.DS._top]) {
              startIndex = i - 1;
              break;
            }
          }

          state.startIndex = Math.max(0, startIndex - 10);
          state.stopIndex = Math.min(state.startIndex + _this.showCount + 10, dataSource.length);
        }

        _this.sizeManager.update({
          _startIndex: state.startIndex,
          _stopIndex: state.stopIndex
        });

        for (var key in _this._forceTable) {
          if (_this._forceTable.hasOwnProperty(key) && _this._forceTable[key]) {
            if (target) {
              if (key.endsWith('body')) {
                _this._forceTable[key](state);
              }
            } else {
              _this._forceTable[key](state);
            }
          }
        }
      });

      _defineProperty(_assertThisInitialized(_this), 'handleExpandChange', function(key) {
        var onExpandedRowsChange = _this.props.onExpandedRowsChange;
        var dataManager = _this.dataManager;
        var result = dataManager.expanded(key);

        if (typeof onExpandedRowsChange === 'function') {
          onExpandedRowsChange(result);
        }

        var change = _this.getShowCount();

        _this.sizeManager.update({
          _dataHeight: _this.dataManager._bodyHeight
        });

        _this.resetShowData();

        if (change) {
          _this.forceUpdate();
        }
      });

      _defineProperty(_assertThisInitialized(_this), 'saveRef', function(name) {
        return function(node) {
          _this[name] = node;
        };
      });

      _defineProperty(_assertThisInitialized(_this), 'registerForce', function(name, fn) {
        _this._forceTable[name || 'body'] = fn;
      });

      _defineProperty(_assertThisInitialized(_this), 'getClassName', function() {
        var _classNames;

        var _this$props2 = _this.props,
          prefixCls = _this$props2.prefixCls,
          className = _this$props2.className,
          fixedHeader = _this$props2.fixedHeader,
          bordered = _this$props2.bordered;
        return (0,
        _classnames[
          'default'
        ])(prefixCls, className, ((_classNames = {}), _defineProperty(_classNames, ''.concat(prefixCls, '-fixed-header'), fixedHeader), _defineProperty(_classNames, 'bordered', bordered), _defineProperty(_classNames, ''.concat(prefixCls, '-expanded'), _this.dataManager.isExpanded()), _defineProperty(_classNames, ''.concat(prefixCls, '-scroll-position-y-top'), _this.sizeManager._hasScrollY && _this.sizeManager._scrollTop === 0), _classNames));
      });

      _defineProperty(_assertThisInitialized(_this), 'renderTable', function(options) {
        var fixed = options.fixed;

        var headTable = _react['default'].createElement(_HeadTable['default'], {
          key: 'head',
          fixed: fixed,
          saveRef: _this.saveRef,
          registerForce: _this.registerForce
        });

        var bodyTable = _react['default'].createElement(_BodyTable['default'], {
          key: 'body',
          fixed: fixed,
          saveRef: _this.saveRef,
          handleBodyScroll: _this.handleBodyScroll,
          registerForce: _this.registerForce
        });

        return [headTable, bodyTable];
      });

      _defineProperty(_assertThisInitialized(_this), 'fixedClassName', function(fixed) {
        return ''.concat(_this.props.prefixCls, '-fixed-').concat(fixed);
      });

      _defineProperty(_assertThisInitialized(_this), 'renderMainTable', function() {
        return _this.renderTable({});
      });

      _defineProperty(_assertThisInitialized(_this), 'renderLeftFixedTable', function() {
        var table = _this.renderTable({
          fixed: 'left'
        });

        return _react['default'].createElement(
          'div',
          {
            className: _this.fixedClassName('left')
          },
          table
        );
      });

      _defineProperty(_assertThisInitialized(_this), 'renderRightFixedTable', function() {
        var table = _this.renderTable({
          fixed: 'right'
        });

        return _react['default'].createElement(
          'div',
          {
            className: _this.fixedClassName('right')
          },
          table
        );
      });

      _defineProperty(_assertThisInitialized(_this), 'renderFooter', function() {
        var _this$props3 = _this.props,
          footer = _this$props3.footer,
          footerHeight = _this$props3.footerHeight,
          prefixCls = _this$props3.prefixCls;
        return footer
          ? _react['default'].createElement(
              'div',
              {
                key: 'table-footer',
                className: ''.concat(prefixCls, '-footer'),
                style: {
                  flex: '0 1 '.concat(footerHeight, 'px'),
                  height: footerHeight,
                  color: 'inherit'
                }
              },
              footer(_this.props.dataSource)
            )
          : null;
      });

      _defineProperty(_assertThisInitialized(_this), 'renderEmptyText', function() {
        var _this$props4 = _this.props,
          emptyText = _this$props4.emptyText,
          dataSource = _this$props4.dataSource,
          rowHeight = _this$props4.rowHeight,
          prefixCls = _this$props4.prefixCls,
          fixedHeader = _this$props4.fixedHeader,
          showHeader = _this$props4.showHeader;

        if (dataSource && dataSource.length > 0) {
          return null;
        }

        var style = {
          height: rowHeight,
          lineHeight: rowHeight + 'px',
          flex: '0 1 '.concat(rowHeight, 'px'),
          textAlign: 'center'
        };

        var scrollSizeX = _this.sizeManager.scrollSizeX();

        if (scrollSizeX > 0 && fixedHeader && showHeader) {
          style.marginTop = ''.concat(scrollSizeX, 'px');
        }

        return _react['default'].createElement(
          'div',
          {
            key: 'table-empty-text',
            className: ''.concat(prefixCls, '-empty-text'),
            style: style
          },
          typeof emptyText === 'function' ? emptyText() : emptyText
        );
      });

      _defineProperty(_assertThisInitialized(_this), 'renderChild', function(params) {
        if (!_this._renderEnable) {
          return null;
        }

        _this.onResize(params);

        var _this$props5 = _this.props,
          prefixCls = _this$props5.prefixCls,
          useScrollY = _this$props5.useScrollY;

        var hasLeftFixed = _this.columnManager.isAnyColumnsLeftFixed();

        var hasRightFixed = _this.columnManager.isAnyColumnsRightFixed();

        var style = _objectSpread({}, _this.props.style);

        style.width = _this.sizeManager._wrapperWidth;

        if (useScrollY) {
          style.height = _this.sizeManager._wrapperHeight;
        }

        return _react['default'].createElement(
          'div',
          {
            className: _this.getClassName(),
            ref: _this.saveRef('tableNode'),
            style: style
          },
          _react['default'].createElement(
            'div',
            {
              className: ''.concat(prefixCls, '-content')
            },
            _this.renderMainTable(),
            hasLeftFixed && _this.renderLeftFixedTable(),
            hasRightFixed && _this.renderRightFixedTable()
          ),
          _this.renderFooter()
        );
      });

      _this.lastScrollTop = 0;
      _this.lastScrollLeft = 0;
      _this.refreshAble = true;
      _this.position = [];
      _this.showCount = props.defaultShowCount || 20;
      _this.columnManager = new _ColumnManager['default'](props);
      _this.dataManager = new _DataManager['default']({
        getProps: _this.getProps
      });
      _this.sortManager = new _SortManager['default']({
        columns: _this.columnManager.groupedColumns(),
        sortMulti: props.sortMulti
      });
      _this.sizeManager = new _SizeManager['default'](props);

      _this.sizeManager.update(
        _objectSpread(
          {
            _dataHeight: _this.dataManager._bodyHeight,
            _dataEmpty: _this.dataManager.isEmpty(),
            _scrollSizeX: props.scrollSize.x,
            _scrollSizeY: props.scrollSize.y
          },
          _this.columnManager.headerSize()
        )
      );

      _this.selectManager = new _SelectManager['default']({
        getProps: _this.getProps,
        update: _this.resetShowData
      });
      _this.store = (0, _miniStore.create)({
        currentHoverKey: null,
        orders: _this.sortManager.enabled()
      });
      _this.scrollTo = _this.scrollTo.bind(_assertThisInitialized(_this));
      return _this;
    }

    _createClass(Table, [
      {
        key: 'getChildContext',
        value: function getChildContext() {
          return {
            props: this.props,
            manager: {
              columnManager: this.columnManager,
              dataManager: this.dataManager,
              sortManager: this.sortManager,
              sizeManager: this.sizeManager,
              selectManager: this.selectManager
            },
            expandChange: this.handleExpandChange,
            updateScrollLeft: this.updateScrollLeft,
            update: this.resetShowData,
            getProps: this.getProps
          };
        }
      },
      {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
          var _this2 = this;

          var update = new Set();

          if (!(0, _shallowequal['default'])(nextProps.showStartIndex, this.props.showStartIndex)) {
            this.sizeManager.update({
              _showStartIndex: nextProps.showStartIndex
            });
          }

          if (!(0, _shallowequal['default'])(nextProps.rowSelection, this.props.rowSelection)) {
            this.selectManager.updateSelection(nextProps.rowSelection);
          }

          if (!(0, _shallowequal['default'])(nextProps.dataSource, this.props.dataSource)) {
            this.dataManager.reset(nextProps.dataSource);
            var dh = this.sizeManager._dataHeight;
            this.selectManager.count = this.selectManager.getKeys(this.dataManager.getData()).length;
            this.sizeManager.update({
              _dataHeight: this.dataManager._bodyHeight,
              _dataEmpty: this.dataManager.isEmpty()
            });

            if (dh !== 0 && this.sizeManager._dataHeight === 0) {
              this.sizeManager.update({
                _scrollTop: 0
              });
              this.updateScrollTop({
                scrollTop: 0
              });
            }

            if (
              nextProps.pullDown &&
              dh < this.sizeManager._dataHeight &&
              this.sizeManager._hasScrollY &&
              this.sizeManager._scrollTop < 5
            ) {
              var top = this.sizeManager._dataHeight - dh;
              this.sizeManager.update({
                _scrollTop: this.sizeManager._scrollTop + top
              });
              this.updateScrollTop({
                scrollTop: this.sizeManager._scrollTop
              });
            }

            update.add('updateColumn');
            update.add('getShowCount');
            update.add('resetShowData');
          }

          if (!(0, _shallowequal['default'])(nextProps.columns, this.props.columns)) {
            this.sizeManager.update(this.columnManager.reset(nextProps));
            this.sortManager.update({
              columns: this.columnManager.groupedColumns(),
              sortMulti: nextProps.sortMulti
            });
            this.store.setState({
              orders: this.sortManager.enable
            });
            update.add('updateColumn');
          }

          if (!(0, _shallowequal['default'])(nextProps.expandedRowKeys, this.props.expandedRowKeys)) {
            this.dataManager.resetExpandedRowKeys(nextProps.expandedRowKeys);
            this.sizeManager.update({
              _dataHeight: this.dataManager._bodyHeight,
              _dataEmpty: this.dataManager.isEmpty()
            });
            update.add('getShowCount');
            update.add('resetShowData');
          }

          update.forEach(function(f) {
            return _this2[f]();
          });
        }
      },
      {
        key: 'componentDidUpdate',
        value: function componentDidUpdate() {
          this.setPositionClass();
          this.skipIndex();
        }
      },
      {
        key: 'scrollTo',
        value: function scrollTo(t) {
          var target = this['bodyTable'];
          if (!target) return;
          var clientHeight = target.clientHeight;
          var scrollHeight = target.scrollHeight;
          var scrollTop = Math.min(t, scrollHeight - clientHeight);
          this.updateScrollTop({
            scrollTop: scrollTop
          });
          this.sizeManager.update({
            _scrollTop: scrollTop
          });
          this.resetShowData();
        }
      },
      {
        key: 'render',
        value: function render() {
          var _this$props6 = this.props,
            prefixCls = _this$props6.prefixCls,
            useScrollY = _this$props6.useScrollY;

          var autoSizeProps = _objectSpread({}, this.props, {
            onResize: this.onResize,
            className: ''.concat(prefixCls, '-auto-size'),
            disableHeight: !useScrollY
          });

          return _react['default'].createElement(
            _miniStore.Provider,
            {
              store: this.store
            },
            _react['default'].createElement(_AutoSizer['default'], autoSizeProps, this.renderChild)
          );
        }
      }
    ]);

    return Table;
  })(_react['default'].PureComponent);

exports['default'] = Table;

_defineProperty(Table, 'defaultProps', _types.TableDefaultParams);

_defineProperty(Table, 'childContextTypes', {
  props: _propTypes['default'].object,
  manager: _propTypes['default'].object,
  expandChange: _propTypes['default'].func,
  updateScrollLeft: _propTypes['default'].func,
  update: _propTypes['default'].func,
  getProps: _propTypes['default'].func
});
