'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = void 0;

var _types = require('../types');

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError('Cannot call a class as a function');
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ('value' in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {value: value, enumerable: true, configurable: true, writable: true});
  } else {
    obj[key] = value;
  }
  return obj;
}

var SelectManager =
  /*#__PURE__*/
  (function() {
    function SelectManager(props) {
      var _this = this;

      _classCallCheck(this, SelectManager);

      _defineProperty(this, '_selectedKeys', []);

      _defineProperty(this, '_type', 'checkbox');

      _defineProperty(this, '_useSelectAll', false);

      _defineProperty(this, '_enable', false);

      _defineProperty(this, '_selectedAll', false);

      _defineProperty(this, '_disabled', []);

      _defineProperty(this, '_count', 0);

      _defineProperty(this, 'getKeys', function(arr, keys) {
        arr = arr || [];
        keys = keys || [];

        for (var i = 0; i < arr.length; i++) {
          keys.push(arr[i][_types.DS._key]);
          var children = arr[i].children || [];

          if (children.length > 0) {
            _this.getKeys(children, keys);
          }
        }

        return keys;
      });

      _defineProperty(this, 'selectAll', function(keys) {
        var _this$getProps = _this.getProps('rowSelection'),
          onSelect = _this$getProps.onSelect,
          type = _this$getProps.type;

        _this._selectedAll = !_this._selectedAll;

        if (_this._selectedAll) {
          _this._selectedKeys = keys;
        } else {
          _this._selectedKeys = [];
        }

        if (typeof onSelect === 'function') {
          onSelect(null, _this._selectedAll, _this._selectedKeys);
        }

        _this.update();
      });

      _defineProperty(this, 'disabled', function(record) {
        return _this._disabled.includes(record[_types.DS._key]);
      });

      _defineProperty(this, 'select', function(record, selected) {
        var _this$getProps2 = _this.getProps('rowSelection'),
          onSelect = _this$getProps2.onSelect,
          type = _this$getProps2.type;

        var t = type || _this._type;

        if (t === 'checkbox') {
          var keys = _this.getKeys([record]);

          if (selected) {
            for (var i = 0; i < keys.length; i++) {
              if (!_this._selectedKeys.includes(keys[i])) {
                _this._selectedKeys.push(keys[i]);
              }
            }
          } else {
            _this._selectedKeys = _this._selectedKeys.filter(function(k) {
              return !keys.includes(k);
            });
          }
        } else if (t === 'radio') {
          if (_this._selectedKeys.includes(record[_types.DS._key])) {
            return false;
          } else {
            _this._selectedKeys = [record[_types.DS._key]];
          }
        }

        if (typeof onSelect === 'function') {
          onSelect(record, selected, _this._selectedKeys);
        }

        _this._selectedAll = _this._selectedKeys.length === _this._count;

        _this.update();
      });

      _defineProperty(this, 'updateSelection', function(rowSelection) {
        _this.getSelection(rowSelection);

        _this.update();
      });

      _defineProperty(this, 'getSelection', function(rowSelection) {
        _this._enable = !!rowSelection;

        if (_this._enable) {
          ['selectedKeys', 'type', 'useSelectAll', 'disabled'].forEach(function(k) {
            if (Object.prototype.hasOwnProperty.call(rowSelection, k)) {
              _this['_'.concat(k)] = rowSelection[k];
            }
          });
          _this._selectedKeys = _this._selectedKeys || [];
          _this._disabled = (_this._disabled || []).map(function(d) {
            return d + '';
          });
          _this._type = _this._type || 'checkbox';

          if (_this._type === 'radio' && _this._selectedKeys.length > 1) {
            _this._selectedKeys = [];
          }

          _this._useSelectAll = !!_this._useSelectAll;
        }
      });

      this.getProps = props.getProps;
      this.update = props.update;

      var _rowSelection = props.getProps('rowSelection');

      this.getSelection(_rowSelection);
    }

    _createClass(SelectManager, [
      {
        key: 'enable',
        get: function get() {
          return this._enable;
        }
      },
      {
        key: 'type',
        get: function get() {
          return this._type;
        }
      },
      {
        key: 'selectedKeys',
        get: function get() {
          return this._selectedKeys || [];
        }
      },
      {
        key: 'useSelectAll',
        get: function get() {
          return this._useSelectAll;
        }
      },
      {
        key: 'selectedAll',
        get: function get() {
          return this._selectedAll;
        }
      },
      {
        key: 'count',
        set: function set(c) {
          this._count = c;
        }
      }
    ]);

    return SelectManager;
  })();

exports['default'] = SelectManager;
