'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = void 0;

var _react = _interopRequireDefault(require('react'));

function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : {default: obj};
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError('Cannot call a class as a function');
  }
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {value: value, enumerable: true, configurable: true, writable: true});
  } else {
    obj[key] = value;
  }
  return obj;
}

var SizeManager = function SizeManager(_ref) {
  var _this = this;

  var showHeader = _ref.showHeader,
    footerHeight = _ref.footerHeight,
    rowHeight = _ref.rowHeight,
    footer = _ref.footer,
    dataSource = _ref.dataSource,
    useScrollY = _ref.useScrollY,
    fixedHeader = _ref.fixedHeader,
    showStartIndex = _ref.showStartIndex;

  _classCallCheck(this, SizeManager);

  _defineProperty(this, '_dataWidth', 0);

  _defineProperty(this, '_dataHeight', 0);

  _defineProperty(this, '_wrapperWidth', 0);

  _defineProperty(this, '_wrapperHeight', 0);

  _defineProperty(this, '_leftWidth', 0);

  _defineProperty(this, '_rightWidth', 0);

  _defineProperty(this, '_headerWidth', 0);

  _defineProperty(this, '_headerHeight', 0);

  _defineProperty(this, '_scrollTop', 0);

  _defineProperty(this, '_scrollLeft', 0);

  _defineProperty(this, '_startIndex', 0);

  _defineProperty(this, '_stopIndex', 0);

  _defineProperty(this, '_scrollSizeY', 0);

  _defineProperty(this, '_scrollSizeX', 0);

  _defineProperty(this, '_showCount', 10);

  _defineProperty(this, '_hasScrollX', false);

  _defineProperty(this, '_hasScrollY', false);

  _defineProperty(this, '_dataEmpty', true);

  _defineProperty(this, '_clientBodyHeight', 0);

  _defineProperty(this, '_showStartIndex', 0);

  _defineProperty(this, 'update', function() {
    var size = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    for (var key in size) {
      if (size.hasOwnProperty(key)) {
        _this[key] = size[key];
      }
    }

    _this.clientBodyHeight();

    _this._emptyTextHeight = _this._dataEmpty ? _this.rowHeight : 0;

    _this.setHasScrollY();
  });

  _defineProperty(this, 'setHasScrollY', function() {
    _this._hasScrollY = _this.useScrollY && _this._wrapperHeight > 0 && _this._wrapperHeight < _this._totalHeight();
  });

  _defineProperty(this, 'clientBodyHeight', function() {
    var height = _this._wrapperHeight - _this.footerHeight;
    height = height - (_this.showHeader && _this.fixedHeader ? _this._headerHeight : 0);
    _this._clientBodyHeight = height;
  });

  _defineProperty(this, 'scrollSizeX', function() {
    return _this._hasScrollX ? _this._scrollSizeX : 0;
  });

  _defineProperty(this, 'scrollSizeY', function() {
    return _this._hasScrollY ? _this._scrollSizeY : 0;
  });

  _defineProperty(this, '_totalHeight', function() {
    return (
      _this._dataHeight +
      (_this.showHeader ? _this._headerHeight : 0) +
      _this.footerHeight +
      _this._emptyTextHeight +
      (_this._hasScrollX && _this._scrollSizeY ? _this._scrollSizeY : 0)
    );
  });

  this.showHeader = showHeader;
  this.fixedHeader = fixedHeader;
  this.footerHeight = footer ? footerHeight : 0;
  this.rowHeight = rowHeight;
  this.useScrollY = useScrollY;
  this._showStartIndex = showStartIndex;
  dataSource = dataSource || [];
  this._dataEmpty = dataSource.length === 0;
  this._emptyTextHeight = this._dataEmpty ? rowHeight : 0;
  this.setHasScrollY();
  this.clientBodyHeight();
};

var _default = SizeManager;
exports['default'] = _default;
