'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = void 0;

var _react = _interopRequireDefault(require('react'));

function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : {default: obj};
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError('Cannot call a class as a function');
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ('value' in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {value: value, enumerable: true, configurable: true, writable: true});
  } else {
    obj[key] = value;
  }
  return obj;
}

var SortManager =
  /*#__PURE__*/
  (function() {
    function SortManager(_ref) {
      var _this = this;

      var _columns = _ref.columns,
        _sortMulti = _ref.sortMulti;

      _classCallCheck(this, SortManager);

      _defineProperty(this, '_cached', {});

      _defineProperty(this, 'update', function(_ref2) {
        var columns = _ref2.columns,
          sortMulti = _ref2.sortMulti;
        _this.columns = columns;
        _this.sortMulti = sortMulti;
        _this.enable = {};
        _this.enable = _this._enable(columns);
      });

      _defineProperty(this, '_enable', function(columns) {
        var order = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

        for (var i = 0; i < columns.length; i++) {
          var column = columns[i] || {};
          var children = column.children || [];

          if (children.length > 0) {
            order = _this._enable(children, order);
          } else {
            if (column.sortEnable) {
              order[column.dataIndex] = column.order;
            }
          }
        }

        return order;
      });

      this.columns = _columns;
      this.sortMulti = _sortMulti;
      this.enable = this._enable(_columns);
    }

    _createClass(SortManager, [
      {
        key: 'enabled',
        value: function enabled() {
          var _this2 = this;

          return this._cache('enabled', function() {
            return _this2.enable;
          });
        }
      },
      {
        key: 'setOrder',
        value: function setOrder(key, order, fn) {
          if (!this.sortMulti) {
            this.enable = _defineProperty({}, ''.concat(key), order);
          }

          this.enable[key] = order;

          if (typeof fn === 'function') {
            fn(this.enable);
          }
        }
      },
      {
        key: '_cache',
        value: function _cache(name, fn) {
          if (name in this._cached) {
            return this._cached[name];
          }

          this._cached[name] = fn();
          return this._cached[name];
        }
      }
    ]);

    return SortManager;
  })();

exports['default'] = SortManager;
