'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = connect;

var _react = require('react');

var _shallowequal = _interopRequireDefault(require('shallowequal'));

var _hoistNonReactStatics = _interopRequireDefault(require('hoist-non-react-statics'));

var _PropTypes = require('./PropTypes');

function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : {default: obj};
}

function _typeof(obj) {
  '@babel/helpers - typeof';
  if (typeof Symbol === 'function' && typeof Symbol.iterator === 'symbol') {
    _typeof = function _typeof(obj) {
      return typeof obj;
    };
  } else {
    _typeof = function _typeof(obj) {
      return obj && typeof Symbol === 'function' && obj.constructor === Symbol && obj !== Symbol.prototype
        ? 'symbol'
        : typeof obj;
    };
  }
  return _typeof(obj);
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly)
      symbols = symbols.filter(function(sym) {
        return Object.getOwnPropertyDescriptor(object, sym).enumerable;
      });
    keys.push.apply(keys, symbols);
  }
  return keys;
}

function _objectSpread(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};
    if (i % 2) {
      ownKeys(Object(source), true).forEach(function(key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function(key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }
  return target;
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError('Cannot call a class as a function');
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ('value' in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _possibleConstructorReturn(self, call) {
  if (call && (_typeof(call) === 'object' || typeof call === 'function')) {
    return call;
  }
  return _assertThisInitialized(self);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf
    ? Object.getPrototypeOf
    : function _getPrototypeOf(o) {
        return o.__proto__ || Object.getPrototypeOf(o);
      };
  return _getPrototypeOf(o);
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }
  return self;
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== 'function' && superClass !== null) {
    throw new TypeError('Super expression must either be null or a function');
  }
  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {value: subClass, writable: true, configurable: true}
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf =
    Object.setPrototypeOf ||
    function _setPrototypeOf(o, p) {
      o.__proto__ = p;
      return o;
    };
  return _setPrototypeOf(o, p);
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {value: value, enumerable: true, configurable: true, writable: true});
  } else {
    obj[key] = value;
  }
  return obj;
}

function getDisplayName(WrappedComponent) {
  return WrappedComponent.displayName || WrappedComponent.name || 'Component';
}

var defaultMapStateToProps = function defaultMapStateToProps() {
  return {};
};

function connect(mapStateToProps) {
  var shouldSubscribe = !!mapStateToProps;
  var finnalMapStateToProps = mapStateToProps || defaultMapStateToProps;
  return function wrapWithConnect(WrappedComponent) {
    var Connect =
      /*#__PURE__*/
      (function(_Component) {
        _inherits(Connect, _Component);

        function Connect(props, context) {
          var _this;

          _classCallCheck(this, Connect);

          _this = _possibleConstructorReturn(this, _getPrototypeOf(Connect).call(this, props, context));

          _defineProperty(_assertThisInitialized(_this), 'handleChange', function() {
            if (!_this.unsubscribe) {
              return;
            }

            var nextState = finnalMapStateToProps(_this.store.getState(), _this.props);

            if (!(0, _shallowequal['default'])(_this.nextState, nextState)) {
              _this.nextState = nextState;

              _this.setState({
                subscribed: nextState
              });
            }
          });

          _this.store = context.miniStore;
          _this.state = {
            subscribed: finnalMapStateToProps(_this.store.getState(), props)
          };
          return _this;
        }

        _createClass(Connect, [
          {
            key: 'componentDidMount',
            value: function componentDidMount() {
              this.trySubscribe();
            }
          },
          {
            key: 'componentWillUnmount',
            value: function componentWillUnmount() {
              this.tryUnsubscribe();
            }
          },
          {
            key: 'trySubscribe',
            value: function trySubscribe() {
              if (shouldSubscribe) {
                this.unsubscribe = this.store.subscribe(this.handleChange);
                this.handleChange();
              }
            }
          },
          {
            key: 'tryUnsubscribe',
            value: function tryUnsubscribe() {
              if (this.unsubscribe) {
                this.unsubscribe();
                this.unsubscribe = null;
              }
            }
          },
          {
            key: 'render',
            value: function render() {
              return (0, _react.createElement)(
                WrappedComponent,
                _objectSpread({}, this.props, {}, this.state.subscribed, {
                  store: this.store
                })
              );
            }
          }
        ]);

        return Connect;
      })(_react.Component);

    _defineProperty(Connect, 'displayName', 'Connect('.concat(getDisplayName(WrappedComponent), ')'));

    _defineProperty(Connect, 'contextTypes', {
      miniStore: _PropTypes.storeShape.isRequired
    });

    return (0, _hoistNonReactStatics['default'])(Connect, WrappedComponent);
  };
}
