'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports.eventsMap = exports.rowEvents = exports.DS = exports.CS = exports.TableDefaultParams = void 0;

var _react = _interopRequireDefault(require('react'));

function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : {default: obj};
}

function defaultFunction() {
  return {};
}

var TableDefaultParams = {
  prefixCls: 'vt',
  columns: [],
  dataSource: [],
  showHeader: true,
  bordered: false,
  fixedHeader: true,
  sortMulti: false,
  refreshEnable: true,
  expandedRowByClick: true,
  useScrollY: true,
  hoverEnable: true,
  headerSortable: false,
  pullDown: false,
  getRowHeight: function getRowHeight() {
    return 1;
  },
  rowClassName: function rowClassName() {
    return '';
  },
  emptyText: function emptyText() {
    return '暂无数据';
  },
  onScrollEnd: function onScrollEnd() {
    return null;
  },
  onExpandedRowsChange: function onExpandedRowsChange() {
    return null;
  },
  getScrollSize: function getScrollSize() {
    return {
      x: 8,
      y: 8
    };
  },
  onRow: defaultFunction,
  onHeaderRow: defaultFunction,
  onHeaderSortable: defaultFunction,
  rowHeight: 30,
  headerRowHeight: 35,
  footerHeight: 30,
  defaultShowCount: 20,
  showStartIndex: 0,
  colMinWidth: 100,
  scrollEndPosition: 60,
  indentSize: 17,
  scrollSize: {
    x: 8,
    y: 8
  },
  style: {}
};
exports.TableDefaultParams = TableDefaultParams;
var CS = {
  _path: String('_path'),
  _pathKey: String('_pathKey'),
  _currentRow: String('_currentRow'),
  _width: String('_width'),
  _minWidth: String('_minWidth'),
  path: String('path'),
  rowSpan: String('rowSpan'),
  colSpan: String('colSpan')
};
exports.CS = CS;
var DS = {
  _index: String('_index'),
  _showIndex: String('_showIndex'),
  _path: String('_path'),
  _expandedLevel: String('_expandedLevel'),
  _height: String('_height'),
  key: String('key'),
  _expandedEnable: String('_expandedEnable'),
  _isFixed: String('_isFixed'),
  _top: String('_top'),
  _expanded: String('_expanded'),
  _key: String('_key'),
  _rowClassName: String('_rowClassName')
}; // export const CS = {
//   _path: Symbol('_path'),
//   _pathKey: Symbol('_pathKey'),
//   _currentRow: Symbol('_currentRow'),
//   _width: Symbol('_width'),
//   _minWidth: Symbol('_minWidth'),
//   path: Symbol('path'),
//   rowSpan: Symbol('rowSpan'),
//   colSpan: Symbol('colSpan')
// };
//
// export const DS = {
//   _index: Symbol('_index'),
//   _showIndex: Symbol('_showIndex'),
//   _path: Symbol('_path'),
//   _expandedLevel: Symbol('_expandedLevel'),
//   _height: Symbol('_height'),
//   key: Symbol('key'),
//   _expandedEnable: Symbol('_expandedEnable'),
//   _isFixed: Symbol('_isFixed'),
//   _top: Symbol('_top'),
//   _expanded: Symbol('_expanded'),
//   _key: Symbol('_key'),
//   _rowClassName: Symbol('_rowClassName')
// };

exports.DS = DS;
var rowEvents = [
  'onMouseEnter',
  'onMouseLeave',
  'onClick',
  'onDoubleClick',
  'onBlur',
  'onFocus',
  'onAnimationStart',
  'onAnimationEnd',
  'onTransitionEnd'
];
exports.rowEvents = rowEvents;
var eventsMap = {
  mouseenter: 'onMouseEnter',
  mouseleave: 'onMouseLeave',
  click: 'onClick',
  doubleclick: 'onDoubleClick',
  blur: 'onBlur',
  focus: 'onFocus',
  animationstart: 'onAnimationStart',
  animationend: 'onAnimationEnd',
  transitionend: 'onTransitionEnd'
};
exports.eventsMap = eventsMap;
